diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/bindings/callbacks_list.py ns-3.36/src/wave/bindings/callbacks_list.py
--- ns-3.35/src/wave/bindings/callbacks_list.py	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wave/bindings/callbacks_list.py	2022-04-30 18:23:58.186735200 -0700
@@ -18,41 +18,40 @@
     ['void', 'const ns3::Ipv6Header &', 'ns3::Ptr<const ns3::Packet>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'std::basic_string<char>', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['unsigned long', 'unsigned short', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned long', 'const ns3::WifiTxVector &', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['bool', 'unsigned short', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::RxSignalInfo', 'ns3::WifiTxVector', 'std::vector<bool, std::allocator<bool>>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Time', 'ns3::Time', 'WifiPhyState', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::WifiMode', 'ns3::WifiPreamble', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiMode', 'ns3::WifiPreamble', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'std::unordered_map<unsigned short, ns3::Ptr<const ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<const ns3::WifiPsdu>>>>', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'std::map<std::pair<unsigned int, unsigned int>, double, std::less<std::pair<unsigned int, unsigned int>>, std::allocator<std::pair<const std::pair<unsigned int, unsigned int>, double>>>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::WifiTxVector', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiPhyRxfailureReason', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Mac48Address', 'ns3::Mac48Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Mac48Address', 'unsigned char', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Mac48Address', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Time', 'ns3::Mac48Address', 'unsigned char', 'ns3::OriginatorBlockAckAgreement::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::WifiMacDropReason', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'unsigned int', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Time', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'const ns3::WifiMacHeader &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::WifiMacDropReason', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiMacQueueItem>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'unsigned char', 'ns3::Ptr<const ns3::WifiPsdu>', 'const ns3::WifiTxVector &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'unsigned char', 'std::unordered_map<unsigned short, ns3::Ptr<ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<ns3::WifiPsdu> > > > *', 'const std::set<ns3::Mac48Address, std::less<ns3::Mac48Address>, std::allocator<ns3::Mac48Address> > *', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned char', 'std::unordered_map<unsigned short, ns3::Ptr<ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<ns3::WifiPsdu>>>> *', 'const std::set<ns3::Mac48Address, std::less<ns3::Mac48Address>, std::allocator<ns3::Mac48Address>> *', 'unsigned long', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned int', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::QueueDiscItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['bool', 'ns3::Ptr<ns3::WifiMac>', 'const ns3::OrganizationIdentifier &', 'ns3::Ptr<const ns3::Packet>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['bool', 'ns3::Ptr<const ns3::Packet>', 'const ns3::Address &', 'unsigned int', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Address', 'ns3::Address', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Mac48Address', 'unsigned char', 'bool', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Mac48Address', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Time', 'ns3::Mac48Address', 'unsigned char', 'ns3::OriginatorBlockAckAgreement::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Time', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<ns3::WifiMacQueueItem>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::RxSignalInfo', 'ns3::WifiTxVector', 'std::vector<bool, std::allocator<bool> >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Time', 'ns3::Time', 'WifiPhyState', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::WifiMode', 'ns3::WifiPreamble', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiMode', 'ns3::WifiPreamble', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'std::unordered_map<unsigned short, ns3::Ptr<const ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<const ns3::WifiPsdu> > > >', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'std::map<std::pair<unsigned int, unsigned int>, double, std::less<std::pair<unsigned int, unsigned int> >, std::allocator<std::pair<const std::pair<unsigned int, unsigned int>, double> > >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::WifiTxVector', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiPhyRxfailureReason', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
 ]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/CMakeLists.txt ns-3.36/src/wave/CMakeLists.txt
--- ns-3.35/src/wave/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/wave/CMakeLists.txt	2022-04-30 18:23:58.186735200 -0700
@@ -0,0 +1,44 @@
+build_lib(
+  LIBNAME wave
+  SOURCE_FILES
+    helper/wave-bsm-helper.cc
+    helper/wave-bsm-stats.cc
+    helper/wave-helper.cc
+    helper/wave-mac-helper.cc
+    helper/wifi-80211p-helper.cc
+    model/bsm-application.cc
+    model/channel-coordinator.cc
+    model/channel-manager.cc
+    model/channel-scheduler.cc
+    model/default-channel-scheduler.cc
+    model/higher-tx-tag.cc
+    model/ocb-wifi-mac.cc
+    model/vendor-specific-action.cc
+    model/vsa-manager.cc
+    model/wave-frame-exchange-manager.cc
+    model/wave-net-device.cc
+  HEADER_FILES
+    helper/wave-bsm-helper.h
+    helper/wave-bsm-stats.h
+    helper/wave-helper.h
+    helper/wave-mac-helper.h
+    helper/wifi-80211p-helper.h
+    model/bsm-application.h
+    model/channel-coordinator.h
+    model/channel-manager.h
+    model/channel-scheduler.h
+    model/default-channel-scheduler.h
+    model/higher-tx-tag.h
+    model/ocb-wifi-mac.h
+    model/vendor-specific-action.h
+    model/vsa-manager.h
+    model/wave-frame-exchange-manager.h
+    model/wave-net-device.h
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libpropagation}
+    ${libwifi}
+    ${libinternet}
+  TEST_SOURCES test/mac-extension-test-suite.cc
+               test/ocb-test-suite.cc
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/examples/CMakeLists.txt ns-3.36/src/wave/examples/CMakeLists.txt
--- ns-3.35/src/wave/examples/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/wave/examples/CMakeLists.txt	2022-04-30 18:23:58.190735000 -0700
@@ -0,0 +1,41 @@
+build_lib_example(
+  NAME wave-simple-80211p
+  SOURCE_FILES wave-simple-80211p.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libapplications}
+    ${libmobility}
+    ${libnetwork}
+    ${libwifi}
+    ${libwave}
+)
+
+build_lib_example(
+  NAME wave-simple-device
+  SOURCE_FILES wave-simple-device.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libapplications}
+    ${libmobility}
+    ${libnetwork}
+    ${libwifi}
+    ${libwave}
+)
+
+build_lib_example(
+  NAME vanet-routing-compare
+  SOURCE_FILES vanet-routing-compare.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libaodv}
+    ${libapplications}
+    ${libdsr}
+    ${libdsdv}
+    ${libflow-monitor}
+    ${libmobility}
+    ${libnetwork}
+    ${libolsr}
+    ${libpropagation}
+    ${libwifi}
+    ${libwave}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/examples/vanet-routing-compare.cc ns-3.36/src/wave/examples/vanet-routing-compare.cc
--- ns-3.35/src/wave/examples/vanet-routing-compare.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wave/examples/vanet-routing-compare.cc	2022-04-30 18:23:58.190735000 -0700
@@ -81,10 +81,10 @@
  * several different simulation scenarios.
  * For example, to set up a scenario and save the configuration
  * as "scenario1.txt":
- *   ./waf --run "vanet-routing-compare --scenario=1 --saveconfig=scenario1.txt"
+ *   ./ns3 run "vanet-routing-compare --scenario=1 --saveconfig=scenario1.txt"
  * Then, to re-play the scenario using the save configuration
  * settings:
- *   ./waf --run "vanet-routing-compare --loadconfig=scenario1.txt"
+ *   ./ns3 run "vanet-routing-compare --loadconfig=scenario1.txt"
  *
  * Class Diagram:
  *   main()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/helper/wave-helper.cc ns-3.36/src/wave/helper/wave-helper.cc
--- ns-3.35/src/wave/helper/wave-helper.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wave/helper/wave-helper.cc	2022-04-30 18:23:58.190735000 -0700
@@ -23,9 +23,9 @@
 #include "ns3/names.h"
 #include "ns3/abort.h"
 #include "ns3/wave-net-device.h"
+#include "ns3/qos-txop.h"
 #include "ns3/minstrel-wifi-manager.h"
 #include "ns3/radiotap-header.h"
-#include "ns3/unused.h"
 #include "wave-mac-helper.h"
 #include "wave-helper.h"
 
@@ -362,8 +362,7 @@
 {
   try
     {
-      const QosWaveMacHelper& qosMac = dynamic_cast<const QosWaveMacHelper&> (macHelper);
-      NS_UNUSED (qosMac);
+      [[maybe_unused]] const QosWaveMacHelper& qosMac = dynamic_cast<const QosWaveMacHelper&> (macHelper);
     }
   catch (const std::bad_cast &)
     {
@@ -384,8 +383,9 @@
       for (uint32_t j = 0; j != m_physNumber; ++j)
         {
           Ptr<WifiPhy> phy = phyHelper.Create (node, device);
-          phy->ConfigureStandardAndBand (WIFI_PHY_STANDARD_80211p, WIFI_PHY_BAND_5GHZ);
-          phy->SetChannelNumber (ChannelManager::GetCch ());
+          phy->ConfigureStandard (WIFI_STANDARD_80211p);
+          phy->SetOperatingChannel (WifiPhy::ChannelTuple {ChannelManager::GetCch (), 0,
+                                                           WIFI_PHY_BAND_5GHZ, 0});
           device->AddPhy (phy);
         }
 
@@ -459,10 +459,8 @@
           std::map<uint32_t, Ptr<OcbWifiMac> > macs = wave->GetMacs ();
           for ( std::map<uint32_t, Ptr<OcbWifiMac> >::iterator k = macs.begin (); k != macs.end (); ++k)
             {
-              Ptr<RegularWifiMac> rmac = DynamicCast<RegularWifiMac> (k->second);
-
               // Handle any random numbers in the station managers.
-              Ptr<WifiRemoteStationManager> manager = rmac->GetWifiRemoteStationManager ();
+              Ptr<WifiRemoteStationManager> manager = k->second->GetWifiRemoteStationManager ();
               Ptr<MinstrelWifiManager> minstrel = DynamicCast<MinstrelWifiManager> (manager);
               if (minstrel)
                 {
@@ -470,23 +468,23 @@
                 }
 
               PointerValue ptr;
-              rmac->GetAttribute ("Txop", ptr);
+              k->second->GetAttribute ("Txop", ptr);
               Ptr<Txop> txop = ptr.Get<Txop> ();
               currentStream += txop->AssignStreams (currentStream);
 
-              rmac->GetAttribute ("VO_Txop", ptr);
+              k->second->GetAttribute ("VO_Txop", ptr);
               Ptr<QosTxop> vo_txop = ptr.Get<QosTxop> ();
               currentStream += vo_txop->AssignStreams (currentStream);
 
-              rmac->GetAttribute ("VI_Txop", ptr);
+              k->second->GetAttribute ("VI_Txop", ptr);
               Ptr<QosTxop> vi_txop = ptr.Get<QosTxop> ();
               currentStream += vi_txop->AssignStreams (currentStream);
 
-              rmac->GetAttribute ("BE_Txop", ptr);
+              k->second->GetAttribute ("BE_Txop", ptr);
               Ptr<QosTxop> be_txop = ptr.Get<QosTxop> ();
               currentStream += be_txop->AssignStreams (currentStream);
 
-              rmac->GetAttribute ("BK_Txop", ptr);
+              k->second->GetAttribute ("BK_Txop", ptr);
               Ptr<QosTxop> bk_txop = ptr.Get<QosTxop> ();
               currentStream += bk_txop->AssignStreams (currentStream);
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/helper/wifi-80211p-helper.cc ns-3.36/src/wave/helper/wifi-80211p-helper.cc
--- ns-3.35/src/wave/helper/wifi-80211p-helper.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wave/helper/wifi-80211p-helper.cc	2022-04-30 18:23:58.190735000 -0700
@@ -26,7 +26,6 @@
 #include <typeinfo>
 #include "wave-mac-helper.h"
 #include "wifi-80211p-helper.h"
-#include "ns3/unused.h"
 
 namespace ns3 {
 
@@ -75,19 +74,17 @@
 NetDeviceContainer
 Wifi80211pHelper::Install (const WifiPhyHelper &phyHelper, const WifiMacHelper &macHelper, NodeContainer c) const
 {
-  QosWaveMacHelper const * qosMac = dynamic_cast <QosWaveMacHelper const *> (&macHelper);
+  [[maybe_unused]] QosWaveMacHelper const * qosMac = dynamic_cast <QosWaveMacHelper const *> (&macHelper);
   if (qosMac == 0)
     {
-      NqosWaveMacHelper const * nqosMac = dynamic_cast <NqosWaveMacHelper const *> (&macHelper);
+      [[maybe_unused]] NqosWaveMacHelper const * nqosMac = dynamic_cast <NqosWaveMacHelper const *> (&macHelper);
       if (nqosMac == 0)
         {
           NS_FATAL_ERROR ("the macHelper should be either QosWaveMacHelper or NqosWaveMacHelper"
                           ", or should be the subclass of QosWaveMacHelper or NqosWaveMacHelper");
         }
-      NS_UNUSED (nqosMac);
     }
 
-  NS_UNUSED (qosMac);
   return WifiHelper::Install (phyHelper, macHelper, c);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/model/default-channel-scheduler.cc ns-3.36/src/wave/model/default-channel-scheduler.cc
--- ns-3.35/src/wave/model/default-channel-scheduler.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wave/model/default-channel-scheduler.cc	2022-04-30 18:23:58.190735000 -0700
@@ -342,7 +342,7 @@
   Ptr<OcbWifiMac> cchMacEntity = m_device->GetMac (CCH);
   if (Now ().GetMilliSeconds() != 0)
     {
-	  m_phy->SetChannelNumber (CCH);
+	  m_phy->SetOperatingChannel (WifiPhy::ChannelTuple {CCH, 0, WIFI_PHY_BAND_5GHZ, 0});
 	  Time switchTime = m_phy->GetChannelSwitchDelay ();
 	  cchMacEntity->MakeVirtualBusy (switchTime);
     }
@@ -371,7 +371,7 @@
   // second unattached current MAC entity from single PHY device
   curMacEntity->ResetWifiPhy ();
   // third switch PHY device from current channel to next channel;
-  m_phy->SetChannelNumber (nextChannelNumber);
+  m_phy->SetOperatingChannel (WifiPhy::ChannelTuple {nextChannelNumber, 0, WIFI_PHY_BAND_5GHZ, 0});
   // four attach next MAC entity to single PHY device
   nextMacEntity->SetWifiPhy (m_phy);
   // Here channel switch time is required to notify next MAC entity
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/model/ocb-wifi-mac.cc ns-3.36/src/wave/model/ocb-wifi-mac.cc
--- ns-3.35/src/wave/model/ocb-wifi-mac.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wave/model/ocb-wifi-mac.cc	2022-04-30 18:23:58.190735000 -0700
@@ -46,7 +46,7 @@
 OcbWifiMac::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::OcbWifiMac")
-    .SetParent<RegularWifiMac> ()
+    .SetParent<WifiMac> ()
     .SetGroupName ("Wave")
     .AddConstructor<OcbWifiMac> ()
   ;
@@ -59,7 +59,7 @@
   // Let the lower layers know that we are acting as an OCB node
   SetTypeOfStation (OCB);
   // BSSID is still needed in the low part of MAC
-  RegularWifiMac::SetBssid (WILDCARD_BSSID);
+  WifiMac::SetBssid (WILDCARD_BSSID);
 }
 
 OcbWifiMac::~OcbWifiMac (void)
@@ -86,11 +86,11 @@
     {
       uint8_t tid = QosUtilsGetTidForPacket (vsc);
       tid = tid > 7 ? 0 : tid;
-      m_edca[QosUtilsMapTidToAc (tid)]->Queue (vsc, hdr);
+      GetQosTxop (tid)->Queue (vsc, hdr);
     }
   else
     {
-      m_txop->Queue (vsc, hdr);
+      GetTxop ()->Queue (vsc, hdr);
     }
 }
 
@@ -119,7 +119,7 @@
 {
   NS_LOG_WARN ("in OCB mode we should not call GetSsid");
   // we really do not want to return ssid, however we have to provide
-  return RegularWifiMac::GetSsid ();
+  return WifiMac::GetSsid ();
 }
 
 
@@ -140,7 +140,7 @@
 OcbWifiMac::SetLinkUpCallback (Callback<void> linkUp)
 {
   NS_LOG_FUNCTION (this << &linkUp);
-  RegularWifiMac::SetLinkUpCallback (linkUp);
+  WifiMac::SetLinkUpCallback (linkUp);
 
   // The approach taken here is that, from the point of view of a STA
   // in OCB mode, the link is always up, so we immediately invoke the
@@ -152,29 +152,35 @@
 OcbWifiMac::SetLinkDownCallback (Callback<void> linkDown)
 {
   NS_LOG_FUNCTION (this << &linkDown);
-  RegularWifiMac::SetLinkDownCallback (linkDown);
+  WifiMac::SetLinkDownCallback (linkDown);
   NS_LOG_WARN ("in OCB mode the like will never down, so linkDown will never be called");
 }
 
+bool
+OcbWifiMac::CanForwardPacketsTo (Mac48Address to) const
+{
+  return true;
+}
+
 void
 OcbWifiMac::Enqueue (Ptr<Packet> packet, Mac48Address to)
 {
   NS_LOG_FUNCTION (this << packet << to);
-  if (m_stationManager->IsBrandNew (to))
+  if (GetWifiRemoteStationManager ()->IsBrandNew (to))
     {
       //In ad hoc mode, we assume that every destination supports all
       //the rates we support.
       if (GetHtSupported () || GetVhtSupported ())
         {
-          m_stationManager->AddAllSupportedMcs (to);
-          m_stationManager->AddStationHtCapabilities (to, GetHtCapabilities());
+          GetWifiRemoteStationManager ()->AddAllSupportedMcs (to);
+          GetWifiRemoteStationManager ()->AddStationHtCapabilities (to, GetHtCapabilities());
         }
       if (GetVhtSupported ())
         {
-          m_stationManager->AddStationVhtCapabilities (to, GetVhtCapabilities());
+          GetWifiRemoteStationManager ()->AddStationVhtCapabilities (to, GetVhtCapabilities());
         }
-      m_stationManager->AddAllSupportedModes (to);
-      m_stationManager->RecordDisassociated (to);
+      GetWifiRemoteStationManager ()->AddAllSupportedModes (to);
+      GetWifiRemoteStationManager ()->RecordDisassociated (to);
     }
 
   WifiMacHeader hdr;
@@ -226,11 +232,11 @@
     {
       // Sanity check that the TID is valid
       NS_ASSERT (tid < 8);
-      m_edca[QosUtilsMapTidToAc (tid)]->Queue (packet, hdr);
+      GetQosTxop (tid)->Queue (packet, hdr);
     }
   else
     {
-      m_txop->Queue (packet, hdr);
+      GetTxop ()->Queue (packet, hdr);
     }
 }
 
@@ -252,21 +258,21 @@
   Mac48Address from = hdr->GetAddr2 ();
   Mac48Address to = hdr->GetAddr1 ();
 
-  if (m_stationManager->IsBrandNew (from))
+  if (GetWifiRemoteStationManager ()->IsBrandNew (from))
     {
       //In ad hoc mode, we assume that every destination supports all
       //the rates we support.
       if (GetHtSupported () || GetVhtSupported ())
         {
-          m_stationManager->AddAllSupportedMcs (from);
-          m_stationManager->AddStationHtCapabilities (from, GetHtCapabilities());
+          GetWifiRemoteStationManager ()->AddAllSupportedMcs (from);
+          GetWifiRemoteStationManager ()->AddStationHtCapabilities (from, GetHtCapabilities());
         }
       if (GetVhtSupported ())
         {
-          m_stationManager->AddStationVhtCapabilities (from, GetVhtCapabilities());
+          GetWifiRemoteStationManager ()->AddStationVhtCapabilities (from, GetVhtCapabilities());
         }
-      m_stationManager->AddAllSupportedModes (from);
-      m_stationManager->RecordDisassociated (from);
+      GetWifiRemoteStationManager ()->AddAllSupportedModes (from);
+      GetWifiRemoteStationManager ()->RecordDisassociated (from);
     }
 
   if (hdr->IsData ())
@@ -297,7 +303,7 @@
   if (hdr->IsMgt () && hdr->IsAction ())
     {
       // yes, we only care about VendorSpecificAction frame in OCB mode
-      // other management frames will be handled by RegularWifiMac::Receive
+      // other management frames will be handled by WifiMac::Receive
       VendorSpecificActionHeader vsaHdr;
       packet->PeekHeader (vsaHdr);
       if (vsaHdr.GetCategory () == CATEGORY_OF_VSA)
@@ -325,7 +331,7 @@
   // Invoke the receive handler of our parent class to deal with any
   // other frames. Specifically, this will handle Block Ack-related
   // Management Action frames.
-  RegularWifiMac::Receive (Create<WifiMacQueueItem> (packet, *hdr));
+  WifiMac::Receive (Create<WifiMacQueueItem> (packet, *hdr));
 }
 
 void
@@ -336,31 +342,31 @@
   switch (ac)
     {
     case AC_VO:
-      dcf = RegularWifiMac::GetVOQueue ();
+      dcf = WifiMac::GetVOQueue ();
       dcf->SetMinCw ((cwmin + 1) / 4 - 1);
       dcf->SetMaxCw ((cwmin + 1) / 2 - 1);
       dcf->SetAifsn (aifsn);
       break;
     case AC_VI:
-      dcf = RegularWifiMac::GetVIQueue ();
+      dcf = WifiMac::GetVIQueue ();
       dcf->SetMinCw ((cwmin + 1) / 2 - 1);
       dcf->SetMaxCw (cwmin);
       dcf->SetAifsn (aifsn);
       break;
     case AC_BE:
-      dcf = RegularWifiMac::GetBEQueue ();
+      dcf = WifiMac::GetBEQueue ();
       dcf->SetMinCw (cwmin);
       dcf->SetMaxCw (cwmax);
       dcf->SetAifsn (aifsn);
       break;
     case AC_BK:
-      dcf = RegularWifiMac::GetBKQueue ();
+      dcf = WifiMac::GetBKQueue ();
       dcf->SetMinCw (cwmin);
       dcf->SetMaxCw (cwmax);
       dcf->SetAifsn (aifsn);
       break;
     case AC_BE_NQOS:
-      dcf = RegularWifiMac::GetTxop ();
+      dcf = WifiMac::GetTxop ();
       dcf->SetMinCw (cwmin);
       dcf->SetMaxCw (cwmax);
       dcf->SetAifsn (aifsn);
@@ -383,17 +389,22 @@
   uint32_t cwmin = 15;
   uint32_t cwmax = 1023;
 
-  // The special value of AC_BE_NQOS which exists in the Access
-  // Category enumeration allows us to configure plain old DCF.
-  ConfigureEdca (cwmin, cwmax, 2, AC_BE_NQOS);
-
-  // Now we configure the EDCA functions
-  // see IEEE802.11p-2010 section 7.3.2.29
-  // Wave CCH and SCHs set default 802.11p EDCA
-  ConfigureEdca (cwmin, cwmax, 2, AC_VO);
-  ConfigureEdca (cwmin, cwmax, 3, AC_VI);
-  ConfigureEdca (cwmin, cwmax, 6, AC_BE);
-  ConfigureEdca (cwmin, cwmax, 9, AC_BK);
+  if (!GetQosSupported ())
+    {
+      // The special value of AC_BE_NQOS which exists in the Access
+      // Category enumeration allows us to configure plain old DCF.
+      ConfigureEdca (cwmin, cwmax, 2, AC_BE_NQOS);
+    }
+  else
+    {
+      // Now we configure the EDCA functions
+      // see IEEE802.11p-2010 section 7.3.2.29
+      // Wave CCH and SCHs set default 802.11p EDCA
+      ConfigureEdca (cwmin, cwmax, 2, AC_VO);
+      ConfigureEdca (cwmin, cwmax, 3, AC_VI);
+      ConfigureEdca (cwmin, cwmax, 6, AC_BE);
+      ConfigureEdca (cwmin, cwmax, 9, AC_BK);
+    }
 
   // Setup FrameExchangeManager
   m_feManager = CreateObject<WaveFrameExchangeManager> ();
@@ -404,9 +415,9 @@
   m_channelAccessManager->SetupFrameExchangeManager (m_feManager);
   if (GetQosSupported ())
     {
-      for (const auto& pair : m_edca)
+      for (auto& ac : {AC_BE, AC_BK, AC_VI, AC_VO})
         {
-          pair.second->SetQosFrameExchangeManager (DynamicCast<QosFrameExchangeManager> (m_feManager));
+          GetQosTxop (ac)->SetQosFrameExchangeManager (DynamicCast<QosFrameExchangeManager> (m_feManager));
         }
     }
 }
@@ -439,10 +450,10 @@
 OcbWifiMac::CancleTx (enum AcIndex ac)
 {
   NS_LOG_FUNCTION (this << ac);
-  Ptr<QosTxop> queue = m_edca.find (ac)->second;
+  Ptr<QosTxop> queue = GetQosTxop (ac);
   NS_ASSERT (queue != 0);
   // reset and flush queue
-  queue->NotifyChannelSwitching ();
+  queue->GetWifiMacQueue ()->Flush ();
 }
 
 void
@@ -466,7 +477,7 @@
 OcbWifiMac::DoDispose (void)
 {
   NS_LOG_FUNCTION (this);
-  RegularWifiMac::DoDispose ();
+  WifiMac::DoDispose ();
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/model/ocb-wifi-mac.h ns-3.36/src/wave/model/ocb-wifi-mac.h
--- ns-3.35/src/wave/model/ocb-wifi-mac.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wave/model/ocb-wifi-mac.h	2022-04-30 18:23:58.190735000 -0700
@@ -23,7 +23,7 @@
 #define OCB_WIFI_MAC_H
 
 #include "ns3/object-factory.h"
-#include "ns3/regular-wifi-mac.h"
+#include "ns3/wifi-mac.h"
 #include "ns3/wifi-mac-queue.h"
 #include "vendor-specific-action.h"
 #include "wave-net-device.h"
@@ -46,7 +46,7 @@
  * However in simulation nodes are supposed to have GPS synchronization ability,
  * so we will not implement this feature.
  */
-class OcbWifiMac : public RegularWifiMac
+class OcbWifiMac : public WifiMac
 {
 public:
   /**
@@ -126,6 +126,7 @@
    * access is granted to this MAC.
    */
   virtual void Enqueue (Ptr<Packet> packet, Mac48Address to);
+  virtual bool CanForwardPacketsTo (Mac48Address to) const;
   /**
     * \param cwmin the min contention window
     * \param cwmax the max contention window
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wave/model/wave-frame-exchange-manager.cc ns-3.36/src/wave/model/wave-frame-exchange-manager.cc
--- ns-3.35/src/wave/model/wave-frame-exchange-manager.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wave/model/wave-frame-exchange-manager.cc	2022-04-30 18:23:58.190735000 -0700
@@ -133,7 +133,7 @@
     }
 
   m_dcf->NotifyChannelAccessed ();
-  Ptr<WifiMacQueueItem> mpdu = *queue->Peek ()->GetQueueIterator ();
+  Ptr<WifiMacQueueItem> mpdu = queue->Peek ()->GetItem ();
   NS_ASSERT (mpdu != 0);
 
   // assign a sequence number if this is not a fragment nor a retransmission
